unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, ImgList, Menus, Clipbrd;

type
  TfrmMain = class(TForm)
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    RichEdit1: TRichEdit;
    ImageList1: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    MainMenu1: TMainMenu;
    PopupMenu1: TPopupMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Exit2: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    SelectAll1: TMenuItem;
    About1: TMenuItem;
    AboutAsciiPad1: TMenuItem;
    Hello1: TMenuItem;
    Cut2: TMenuItem;
    Paste2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure RichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure New1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure AboutAsciiPad1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  bDirty: Boolean;
  LFile: String;
implementation

uses About;

{$R *.DFM}
function PadStr(Tmp : String): String;
Var
I :Integer;
N :Integer;
tmpStr : String;
begin
i := length(Tmp);
tmpStr := ' ';
for N := 1 to I do
begin
tmpStr := tmpStr + ' ';
end;
PadStr := tmpStr;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
Var
I : integer;
aline : string;
AH : Variant;
begin
AH := 8;
RichEdit1.Lines.Clear;
for i := 0 to RichEdit1.Width do
begin
 aline := aline + ' ';
end;
statusbar1.SimpleText := 'Please Wait';
 richedit1.Visible := false;
for i := 0  to RichEdit1.Height / AH do
begin
RichEdit1.Lines.Append (aline);
end;
richedit1.MaxLength := Length(richedit1.Lines.Text);
richedit1.SelStart := 1;
richedit1.Visible := true;
statusbar1.SimpleText := '';
bdirty := false;
end;

//
procedure TfrmMain.RichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
Var
sKeys :String;
  begin
 sKeys := InttoStr(key);
if sKeys = '37' then
begin
exit;
end;
if sKeys = '38' then
begin
exit;
end;
if sKeys = '39' then
begin
exit;
end;
if sKeys = '40' then
begin
exit;
end;
if sKeys = '8' then
begin
richedit1.SelText := PadStr(richedit1.SelText);
end;
if sKeys = '46' then
begin
richedit1.SelText := PadStr(richedit1.SelText);
end;
richedit1.SelLength :=  1;
richedit1.SelText := '';
bdirty := true;

end;


//
procedure TfrmMain.New1Click(Sender: TObject);
Var
I : integer;
aline : string;
AH : Variant;
begin
AH := 8;
//if saved check
RichEdit1.Lines.Clear;
for i := 0 to RichEdit1.Width do
begin
 aline := aline + ' ';
end;
statusbar1.SimpleText := 'Please Wait';
 richedit1.Visible := false;
for i := 0  to RichEdit1.Height / AH  do
begin
RichEdit1.Lines.Append (aline);
end;
richedit1.MaxLength := Length(richedit1.Lines.Text);
richedit1.SelStart := 1;
richedit1.Visible := true;
statusbar1.SimpleText := 'UnSaved';
LFile := '';
bdirty := false;
end;


procedure TfrmMain.SelectAll1Click(Sender: TObject);
begin
richedit1.SelStart := 1;
richedit1.SelLength := length(richedit1.lines.text);
end;

procedure TfrmMain.N1Click(Sender: TObject);
Var sFile : String;
begin
if SaveDialog1.Execute then
begin
sfile := SaveDialog1.FileName;
richedit1.Lines.SaveToFile(sfile);
statusbar1.SimpleText := sfile;
lFile := sfile;
bDirty := false;
end;

end;

procedure TfrmMain.Save1Click(Sender: TObject);
begin
if lfile <> '' then
begin
//save the file if it has a name
richedit1.Lines.SaveToFile(lfile);
bDirty := False;
end
else  if lfile = '' then
//save as new file
N1.Click;
end;


procedure TfrmMain.Open1Click(Sender: TObject);
begin
//check saved

if OpenDialog1.Execute then
begin
richedit1.Lines.LoadFromFile(OpenDialog1.FileName);
statusbar1.SimpleText := OpenDialog1.FileName;
LFile := OpenDialog1.FileName;
bDirty := False;
end;

end;

procedure TfrmMain.Exit2Click(Sender: TObject);
begin
//saved check
close;
end;

procedure TfrmMain.ToolButton5Click(Sender: TObject);
begin
Richedit1.CopyToClipboard;
end;

procedure TfrmMain.ToolButton6Click(Sender: TObject);
Var
AL : String;
begin
AL := PadStr(Richedit1.seltext);
Richedit1.CopytoClipboard;
Richedit1.SelText := AL;
Richedit1.SelStart :=Richedit1.SelStart - Length(Al);
end;

procedure TfrmMain.ToolButton7Click(Sender: TObject);
Var
Al : String;
HL : Integer;
begin
if Clipboard.HasFormat(CF_TEXT) then
begin
Al := Clipboard.AsText;
HL := Length(Al);
Richedit1.SelLength := HL;
Richedit1.SelText := Al;
end;


end;

procedure TfrmMain.AboutAsciiPad1Click(Sender: TObject);
begin
frmAbout.ShowModal;
end;

end.
